
PWD = $(shell pwd)

export BUILD_TARGET_OBJ_ROOT    = ${PWD}/OSS_Output/directfb
export VM_LINUX_ROOT            = ${PWD}/../../..
export CHILING_ROOT             = ${PWD}/../..

export ARCH             = arm
export ENABLE_CA9_NEON  = true

export TOOL_CHAIN            = 4.8.2
export CROSS_COMPILE   ?= /mtkoss/gnuarm/neon_4.8.2_2.6.35_cortex-a9-ubuntu/i686/bin/armv7a-mediatek482_001_neon-linux-gnueabi-

export KERNEL_VER       ?= linux-3.10
export DIRECTFB_VERSION = 1.5.3

export ZLIB_VERSION     = 1.2.3
export PNG_VERSION      = 1.2.43
export FREETYPE_VERSION = 2.3.9
export JPEG_VERSION     = 6b

export TOP    = ${PWD}
export SOURCE = $(TOP)/directfb_$(DIRECTFB_VERSION)/Source
export KERNEL = $(TOP)/directfb_$(DIRECTFB_VERSION)/Kernel

export LINUX_ETC_PATH   = /mnt/vendor/linux_rootfs/etc
export LINUX_TMP_PATH   = /data/vendor/tmp
export DEFINES          = -DLINUX_ETC_PATH=\"$(LINUX_ETC_PATH)\" \
                          -DLINUX_TMP_PATH=\"$(LINUX_TMP_PATH)\"

export THIRDPARTY_LIB_ROOT = $(TOP)/thirdparty_lib/

export INCLUDES =   -I$(TOP)/MediaTek/mt53xx                        \
                    -I$(TOP)/MediaTek/gfx                           \
                    -I$(TOP)/middleware_header/res_mngr/drv \
                    -I$(TOP)/middleware_header/inc          \
                    -I$(TOP)/middleware_header/os/inc       \
                    -I$(TOP)/middleware_header/handle       \
                    -I$(TOP)/middleware_header/

export CFLAGS   = -w
export CPPFLAGS = -w

export TARGET_IC        = mt5883
export KERNEL_CONFIG    = $(TARGET_IC)_smp_mod_defconfig
export KERNEL_OUT       = ${BUILD_TARGET_OBJ_ROOT}/../${KERNEL_VER}/${KERNEL_CONFIG}

export DFB_OSS_BUILD    = ${MAKECMDGOALS}

USER_BUILD_OPTIONS      = CC=${CROSS_COMPILE}gcc CXX=${CROSS_COMPILE}g++ AR=${CROSS_COMPILE}ar STRIP=${CROSS_COMPILE}strip

KERNEL_BUILD_OPTIONS    = CROSS_COMPILE=${CROSS_COMPILE} ARCH=arm

KERNEL_CONFIG_FILE      ?= tandem_config

kernel:
	@/bin/echo -e "Build the Linux kernel common ..."
	rm -rf ${KERNEL_OUT}
	mkdir -p $(KERNEL_OUT)
	cp ${KERNEL_CONFIG_FILE} $(KERNEL_OUT)/.config
	make mrproper -C $(TOP)/../${KERNEL_VER}
	make -C $(TOP)/../${KERNEL_VER} ${KERNEL_BUILD_OPTIONS} O=$(KERNEL_OUT) modules
libdirectfb.so:
	rm -rf ${BUILD_TARGET_OBJ_ROOT}

	@/bin/echo -e "Build the DirectFB OBJs:"
	make ${USER_BUILD_OPTIONS} gen_obj
	@/bin/echo -e "Build the oss library: libdirectfb.so"
	make ${USER_BUILD_OPTIONS} libdirectfb.so
	cp ${BUILD_TARGET_OBJ_ROOT}/libdirectfb.so ${BUILD_TARGET_OBJ_ROOT}/../

fusion.ko:
	@/bin/echo -e "Build the oss library: fusion.ko"
	make ${KERNEL_BUILD_OPTIONS} O=$(KERNEL_OUT) BUILD_TARGET_OBJ_ROOT=$(BUILD_TARGET_OBJ_ROOT)/fusion/ fusion.ko
	cp ${BUILD_TARGET_OBJ_ROOT}/fusion/fusion.ko ${BUILD_TARGET_OBJ_ROOT}/../

